CREATE SCHEMA projetos;
USE projetos;

CREATE TABLE DEPARTAMENTO (
   DNOME VARCHAR(30),
   DNUMERO INT NOT NULL,
   GERCPF CHAR(11),
   GERDATAINICIO DATE,
   PRIMARY KEY (DNUMERO)
);

CREATE TABLE EMPREGADO (
   PNOME VARCHAR(30),
   MINICIAL VARCHAR(1),
   UNOME VARCHAR(30),
   CPF CHAR(11) NOT NULL,
   DATANASC DATE,
   ENDERECO TEXT,
   SEXO VARCHAR(1),
   SALARIO FLOAT,
   GERENTE_CPF CHAR(11),
   DNO INT,
   PRIMARY KEY (CPF),
   FOREIGN KEY (GERENTE_CPF) REFERENCES EMPREGADO (CPF),
   FOREIGN KEY (DNO) REFERENCES DEPARTAMENTO (DNUMERO)
);

ALTER TABLE DEPARTAMENTO ADD CONSTRAINT DEP_GER_FK FOREIGN KEY (GERCPF) REFERENCES EMPREGADO(CPF);

CREATE TABLE DEPT_LOCALIZACOES (
   DNUMERO INT NOT NULL,
   DLOCALIZACAO VARCHAR(30),
   PRIMARY KEY (DNUMERO,DLOCALIZACAO),
   FOREIGN KEY (DNUMERO) REFERENCES DEPARTAMENTO (DNUMERO)
);

CREATE TABLE PROJETO (
   PJNOME VARCHAR(30),
   PNUMERO INT NOT NULL,
   PLOCALIZACAO VARCHAR(30),
   DNUM INT,
   PRIMARY KEY (PNUMERO),
   UNIQUE(PJNOME),
   FOREIGN KEY (DNUM) REFERENCES DEPARTAMENTO (DNUMERO)
);

CREATE TABLE TRABALHA_EM (
   ECPF CHAR(11) NOT NULL,
   PNO INT NOT NULL,
   HORAS FLOAT,
   PRIMARY KEY (ECPF,PNO),
   FOREIGN KEY (ECPF) REFERENCES EMPREGADO (CPF),
   FOREIGN KEY (PNO) REFERENCES PROJETO (PNUMERO)
);

CREATE TABLE DEPENDENTE (
   ECPF CHAR(11) NOT NULL,
   NOME_DEPENDENTE VARCHAR(30) NOT NULL,
   SEXO VARCHAR(1),
   DATANASC DATE,
   PARENTESCO VARCHAR(30),
   PRIMARY KEY (ECPF, NOME_DEPENDENTE),
   FOREIGN KEY (ECPF) REFERENCES EMPREGADO (CPF)
);
